# 
# Autor: Ney Calazans
# 
#	O objetivo deste programa  mostrar o uso mais bsico da linguagem
#	de montagem do MIPS, atravs de um programa trivial que soma dois
#	nmeros quaiquer de 32 bits (A e B no programa) armazenados em 
#	memria e coloca o resultado em uma terceira posio de memria
#	(C no programa). 
#
#	Note-se que este programa extremamente simples j serve para 
#	demonstrar vrias das idiossincrasias de arquiteturas RISC, das quais
#	o MIPS  um exemplo clssico. Entre estas, cita-se:
#	1) A obteno de um endereo de um dado em memria no pode ser
#	feita de forma simples por uma instruo. O montador SPIM supera 
#	esta limitao provendo uma pseudo-instruo (la) que ser por ele 
#	traduzida durante a gerao do cdigo objeto para instrues da
#	arquitetura MIPS que desempenham este papel (uma seqncia de duas
#	instrues, lui e ori)
#	2) O uso de endereamento base-deslocamento para fazer acesso a
#	qualquer dado em memria. No existem instrues no MIPS que usem 
#	endereamento direto para acesso a memria, sendo necessrio partir
#	de um endereo base e especificar um deslocamento sobre este, que pode
#	obviamente simular endereamento direto, se o deslocaamento for 0.
#	3) O uso da instruo jr para retornar do programa, salientando o
#	fato de que programas escritos operam como subrotinas chamadas pelo
#	ncleo (kernel) do ambiente SPIM.
#

        .text   
        .globl  main            
        
main:   la	$t0,A		# Carrega endereo de A em $t0 - PSEUDO-INSTRUO
	lw	$t0,0($t0)	# L valor de A para $t0
	la	$t1,B		# Carrega endereo de B em $t1 - PSEUDO-INSTRUO
	lw	$t1,0($t1)	# L valor de B para $t1
	addu	$t0,$t0,$t1	# $t0 recebe A+B
	la	$t2,C		# Carrega endereo de C em $t2 - PSEUDO-INSTRUO
	sw	$t0,0($t2)	# C recebe A+B
	
	jr	$ra		# volta para o kernel do simulador
	
	
	.data
A:	.word	32
B:	.word	0xffab3400
C:	.word	0
       


